#ifndef PREFERENCES_H
#define PREFERENCES_H

/*! 
  \file preferences.h
  \brief main interface and operations

  \author R. Enders

  $Revision: 1.6 $
  $Id: preferences.h,v 1.6 2006/01/06 12:18:00 reinhard Exp $
  
  Copyright (C) 2004-2006 by Reinhard Enders
  Reinhard.Enders@gmx.de

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  http://www.gnu.org/copyleft/gpl.html

  \include preferences.h
*/

#include "config.h"
#include <list>
#include <string>
#include <vector>
#include ".ui/preferencesbase.h"

class ParameterBase;

class Preferences : public PreferencesDialog
{
    Q_OBJECT
public:
    Preferences( QWidget* parent = 0, const char* name = 0,
		 bool modal = FALSE, WFlags fl = 0);
    ~Preferences();

public slots:
void preferencesButtonOk();
public:
    void readParams();
    void writeParams();
#ifdef EXPERIMENTAL
protected:
    void setToolTip(QWidget& q, ParameterBase& p);
    template <class Q, class P> void readWidgetParam(QWidget& q, ParameterBase& p);
    void readEditLineParam(QWidget& q, ParameterBase& p);
    void readCheckBoxParam(QWidget& q, ParameterBase& p);
    void readQSliderParam(QWidget& q, ParameterBase& p);
#endif
};


#endif /* PREFERENCES_H */
